<?php
if ( ! class_exists( 'Security_Services_Elementor_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Security_Services_Elementor_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Security_Services_Elementor_Plugin_Activation_WPElemento_Importer {

        private static $security_services_elementor_instance;
        public $security_services_elementor_action_count;
        public $security_services_elementor_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$security_services_elementor_instance) ) {
            self::$security_services_elementor_instance = new self();
          }
          return self::$security_services_elementor_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'security_services_elementor_recommended_plugins', array($this, 'security_services_elementor_recommended_elemento_importer_plugins_array') );

            $security_services_elementor_actions                   = $this->security_services_elementor_get_recommended_actions();
            $this->security_services_elementor_action_count        = $security_services_elementor_actions['count'];
            $this->security_services_elementor_recommended_actions = $security_services_elementor_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function security_services_elementor_recommended_elemento_importer_plugins_array($security_services_elementor_plugins){
            $security_services_elementor_plugins[] = array(
                    'name'     => esc_html__('WPElemento Importer', 'security-services-elementor'),
                    'slug'     =>  'wpelemento-importer',
                    'function' => 'WPElemento_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the WPElemento Importer plugin for importing the demo content with Elementor.', 'security-services-elementor'),               
            );
            return $security_services_elementor_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'security-services-elementor-plugin-activation-script', esc_url(get_template_directory_uri()) . '/includes/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('security-services-elementor-plugin-activation-script', 'security_services_elementor_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'security-services-elementor'),
                    'activating' => esc_html__('Activating', 'security-services-elementor'),
                    'error' => esc_html__('Error', 'security-services-elementor'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=wpelemento-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=wpelementoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'security-services-elementor-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function security_services_elementor_get_recommended_actions() {

            $security_services_elementor_act_count  = 0;
            $security_services_elementor_actions_todo = get_option( 'recommending_actions', array());

            $security_services_elementor_plugins = $this->security_services_elementor_get_recommended_plugins();

            if ($security_services_elementor_plugins) {
                foreach ($security_services_elementor_plugins as $security_services_elementor_key => $security_services_elementor_plugin) {
                    $security_services_elementor_action = array();
                    if (!isset($security_services_elementor_plugin['slug'])) {
                        continue;
                    }

                    $security_services_elementor_action['id']   = 'install_' . $security_services_elementor_plugin['slug'];
                    $security_services_elementor_action['desc'] = '';
                    if (isset($security_services_elementor_plugin['desc'])) {
                        $security_services_elementor_action['desc'] = $security_services_elementor_plugin['desc'];
                    }

                    $security_services_elementor_action['name'] = '';
                    if (isset($security_services_elementor_plugin['name'])) {
                        $security_services_elementor_action['title'] = $security_services_elementor_plugin['name'];
                    }

                    $security_services_elementor_link_and_is_done  = $this->security_services_elementor_get_plugin_buttion($security_services_elementor_plugin['slug'], $security_services_elementor_plugin['name'], $security_services_elementor_plugin['function']);
                    $security_services_elementor_action['link']    = $security_services_elementor_link_and_is_done['button'];
                    $security_services_elementor_action['is_done'] = $security_services_elementor_link_and_is_done['done'];
                    if (!$security_services_elementor_action['is_done'] && (!isset($security_services_elementor_actions_todo[$security_services_elementor_action['id']]) || !$security_services_elementor_actions_todo[$security_services_elementor_action['id']])) {
                        $security_services_elementor_act_count++;
                    }
                    $security_services_elementor_recommended_actions[] = $security_services_elementor_action;
                    $security_services_elementor_actions_todo[]        = array('id' => $security_services_elementor_action['id'], 'watch' => true);
                }
                return array('count' => $security_services_elementor_act_count, 'actions' => $security_services_elementor_recommended_actions);
            }

        }

        public function security_services_elementor_get_recommended_plugins() {

            $security_services_elementor_plugins = apply_filters('security_services_elementor_recommended_plugins', array());
            return $security_services_elementor_plugins;
        }

        public function security_services_elementor_get_plugin_buttion($slug, $name, $function) {
                $security_services_elementor_is_done      = false;
                $security_services_elementor_button_html  = '';
                $security_services_elementor_is_installed = $this->is_plugin_installed($slug);
                $security_services_elementor_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $security_services_elementor_is_activeted = (class_exists($function)) ? true : false;
                if (!$security_services_elementor_is_installed) {
                    $security_services_elementor_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $security_services_elementor_plugin_install_url = wp_nonce_url($security_services_elementor_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $security_services_elementor_button_html        = sprintf('<a class="security-services-elementor-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($security_services_elementor_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'security-services-elementor'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'security-services-elementor')
                    );
                } elseif ($security_services_elementor_is_installed && !$security_services_elementor_is_activeted) {

                    $security_services_elementor_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($security_services_elementor_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $security_services_elementor_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $security_services_elementor_button_html = sprintf('<a class="security-services-elementor-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($security_services_elementor_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'security-services-elementor'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'security-services-elementor')
                    );
                } elseif ($security_services_elementor_is_activeted) {
                    $security_services_elementor_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'security-services-elementor'));
                    $security_services_elementor_is_done     = true;
                }

                return array('done' => $security_services_elementor_is_done, 'button' => $security_services_elementor_button_html);
            }
        public function is_plugin_installed($slug) {
            $security_services_elementor_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $security_services_elementor_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($security_services_elementor_installed_plugins[$security_services_elementor_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $security_services_elementor_keys = array_keys($this->get_installed_plugins());
            foreach ($security_services_elementor_keys as $security_services_elementor_key) {
                if (preg_match('|^' . $slug . '/|', $security_services_elementor_key)) {
                    return $security_services_elementor_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Security_Services_Elementor_Plugin_Activation_WPElemento_Importer::get_instance();